<?php

namespace Drupal\visitors\Service;

use Drupal\Core\Database\Connection;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\visitors\VisitorsTrackerInterface;
use Psr\Log\LoggerInterface;

/**
 * Tracker for web analytics.
 */
class TrackerService implements VisitorsTrackerInterface {

  /**
   * The module handler.
   *
   * @var \Drupal\Core\Extension\ModuleHandlerInterface
   */
  protected $moduleHandler;

  /**
   * The database connection.
   *
   * @var \Drupal\Core\Database\Connection
   */
  protected $database;

  /**
   * The logger.
   *
   * @var \Psr\Log\LoggerInterface
   */
  protected $logger;

  /**
   * Tracks visits and actions.
   *
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler.
   * @param \Drupal\Core\Database\Connection $database
   *   The database connection.
   * @param \Psr\Log\LoggerInterface $logger
   *   The logger.
   */
  public function __construct(ModuleHandlerInterface $module_handler, Connection $database, LoggerInterface $logger) {

    $this->moduleHandler = $module_handler;
    $this->database = $database;
    $this->logger = $logger;

  }

  /**
   * {@inheritdoc}
   */
  public function writeLog($fields): int {
    $id = $this->database->insert('visitors')
      ->fields($fields)
      ->execute();

    return $id;
  }

}
